/*
                       Endeavour Core Callbacks
 */

#ifndef EDVCB_H
#define EDVCB_H

#include <gtk/gtk.h>

#include "edvobj.h"
#include "edvdevices.h"
#include "endeavour.h"


/* Callbacks. */
extern void EDVSignalCB(int s);
extern gint EDVManageTimeoutCB(gpointer data);
extern void EDVNewBrowserCB(GtkWidget *widget, gpointer data);
extern void EDVOptionsCB(GtkWidget *widget, gpointer data);
extern void EDVCustomizeCB(GtkWidget *widget, gpointer data);

extern gint EDVCListColumnSortStringCB(
        GtkCList *clist, gconstpointer ptr1, gconstpointer ptr2
);
extern gint EDVCListColumnSortNumericCB(
        GtkCList *clist, gconstpointer ptr1, gconstpointer ptr2
);



/* Emitters. */
extern void EDVWriteProtectChangedEmit(
	edv_core_struct *core_ptr, gbool state
);

extern void EDVObjectAddedEmit(
	edv_core_struct *core_ptr, const gchar *path,
	const struct stat *lstat_buf
);
extern void EDVObjectModifiedEmit(
        edv_core_struct *core_ptr, const gchar *path,
	const gchar *new_path,
        const struct stat *lstat_buf
);
extern void EDVObjectRemovedEmit(
	edv_core_struct *core_ptr, const gchar *path
);

extern void EDVObjectMountEmit(
	edv_core_struct *core_ptr,
	gint dev_num, edv_device_struct *dev_ptr,
	gbool is_mounted
);

extern void EDVRecycledObjectAddedEmit(
        edv_core_struct *core_ptr, guint index
);
extern void EDVRecycledObjectRemovedEmit(
        edv_core_struct *core_ptr, guint index
);

extern void EDVReconfiguredEmit(edv_core_struct *core_ptr);

extern void EDVMimeTypeAddedEmit(
        edv_core_struct *core_ptr,
        gint mt_num, edv_mimetype_struct *mt_ptr
);
extern void EDVMimeTypeModifiedEmit(
        edv_core_struct *core_ptr,
        gint mt_num, edv_mimetype_struct *mt_ptr
);
extern void EDVMimeTypeRemovedEmit(
        edv_core_struct *core_ptr, gint mt_num
);

extern void EDVDeviceAddedEmit(
        edv_core_struct *core_ptr,
        gint dev_num, edv_device_struct *dev_ptr
);
extern void EDVDeviceModifiedEmit(
        edv_core_struct *core_ptr,
        gint dev_num, edv_device_struct *dev_ptr
);
extern void EDVDeviceRemovedEmit(
        edv_core_struct *core_ptr, gint dev_num
);

#endif	/* EDVCB_H */
