/*
            Endeavour Dynamic Data Exchange (DDE) Converters
 */

#ifndef EDVDDE_H
#define EDVDDE_H

#include <sys/types.h>
#include <glib.h>


#if 0

/*
 *	Magic numbers used to identify buffers, these are always the
 *	first four bytes of any dnd data buffer.
 */
#define EDV_DND_MAGIC_OBJECT	0x6020a080


/*
 *	DND object types:
 */
#define EDV_DND_OBJECT_TYPE_NONE		0
#define EDV_DND_OBJECT_TYPE_DISK_OBJECT		10
#define EDV_DND_OBJECT_TYPE_RECYCLED_OBJECT	20

#endif



/*
 *	Disk object dnd source widget data structure:
 */
typedef struct {

#if 0
	/* Pointer to an edv_core_struct, may be on separate process
	 * so do not reference it.
	 */
	gpointer core_ptr;

	/* DND object type, one of EDV_DND_OBJECT_*. */
	gint object_type;
#endif

	/* Protocol (file, ftp, http, etc). */
	gchar *protocol;

	/* Host address. */
	gchar *host_address;

	/* If object_type is EDV_DND_OBJECT_TYPE_DISK_OBJECT then
	 * this value is the full path to the disk object.
	 *
	 * If object_type is EDV_DND_OBJECT_TYPE_RECYCLED_OBJECT then
	 * this value is a string containing the index number of the
	 * recycled object.
	 */
	gchar *full_path;

} edv_dnd_object_struct;


extern edv_dnd_object_struct *EDVDNDObjectNew(void);
extern void EDVDNDObjectDelete(edv_dnd_object_struct *dnd_obj);

extern guint8 *EDVDNDObjectToBuffer(
	const edv_dnd_object_struct **dnd_object, gint total_dnd_objects,
	gint *buf_len
);
extern edv_dnd_object_struct **EDVDNDBufferToObject(
	const guint8 *buf, gint buf_len,
	gint *total_dnd_objects
);


#endif	/* EDVDDE_H */
